=== openshift/origin@v0.0.0-20160503220234-8f127d736703/Godeps/_workspace/src/github.com/vjeantet/asn1-ber/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

include $(GOROOT)/src/Make.inc

TARG=github.com/mmitton/asn1-ber
GOFILES=\
	ber.go\

include $(GOROOT)/src/Make.pkg
