=== rubiojr/go-vhd@v0.0.0-20160810183302-0bfd3b39853c/debian/control ===
Source: go-vhd
Section: net
Priority: extra
Maintainer: Sergio Rubio <rubiojr@frameos.org>
Build-Depends: debhelper (>= 8.0.0),
               golang-go
Standards-Version: 3.9.2
#Vcs-Git: git://github.com/rubiojr/go-vhd.git
#Vcs-Browser: http://github.com/rubiojr/go-vhd

Package: go-vhd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: Create and manipulate VHD images
  * Create VHD dynamic images
  * Convert RAW to fixed VHD
  * Inspect VHD headers
